﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WinGrid___Column_Header_Click___CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridOverride ov = layout.Override;

            // This basically tells the grid to do nothing when a header is clicked. 
            ov.HeaderClickAction = HeaderClickAction.Select;
            ov.SelectTypeCol = SelectType.None;
        }

        private void ultraGrid1_MouseUp(object sender, MouseEventArgs e)
        {
            UltraGrid grid = (UltraGrid)sender;
            UIElement element = grid.DisplayLayout.UIElement.LastElementEntered;

            // First, check if the element itself is a HeaderUIElement. 
            HeaderUIElement headerUIElement = element as HeaderUIElement;

            // If not, see if it has an ancestor that it a HeaderUIElement
            if (null == headerUIElement)
                headerUIElement = element.GetAncestor(typeof(HeaderUIElement)) as HeaderUIElement;

            // If we didn't find a HeaderUIElemnt by now, then the mouse is not in a Header. 
            if (null == headerUIElement)
                return;

            // Now get the column. 
            UltraGridColumn column = headerUIElement.Header.Column;
            if (null == column)
            {
                // The column will be null if the HeaderUIElement is a Band or Group Header. 
                return;
            }

            MessageBox.Show(this, "Header clicked:  " + column.Key);                
        }
    }
}
